-- $Id: quest.lua,v 1.3 2003/02/05 15:13:56 mat Exp $
-- Arkhart RPG - An Ark-based roleplaying game.
-- Copyright (C) 2001 The Contributors of the Arkhart Project
-- Please see the file "AUTHORS" for a list of contributors
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

ark.log ("Loading demo quest...");

fermiere = {};

function fermiere.on_create (self)
	self:play_anim (ark.play_loop, "idle");
	self.state = 1;
end;

maison = {}

function maison.on_create(self)
	position = self:get_position();
--	ark.log ("bouh maison @ (" .. position.x .. ", " .. position.z .. ")");
--	self:add_timer (1, 4.0);
end

function carre(x)
	return (x*x);
end

function find_player(bouh)
	player = ark.world:get_entity_by_name("Player0");
	return (player);
end

function distance(entity)
	position = entity:get_position();
	player = find_player(0);
	player_position = player:get_position();
	return (sqrt(carre(position.x - player_position.x) + carre(position.z - player_position.z)));
end

function maison.on_timer (self, id)
-- 	self:add_timer (id, 4.0);
--	player = find_player();
-- 	self:add_message(player, "bouh", {"oue c'est bon jai compris"});
-- 	position = self:get_position();
-- 	if (distance(self) < 20) then
-- 	  ark.log ("playing Fermus_orchest.xm");
-- 	  self:play_music("{musics}/Fermus_orchest.xm");
-- 	end
end

function maison.on_tell (self, ent, msg)
 	ark.log ("maison reveived a message !");
end

function fermiere.on_tell (self, ent, msg)
	ark.log (self:get_name() .. " was told " .. msg);
	if (msg == "MOUSEHIT") then -- click soit initial soit si on est sorti/revenu du dialogue
		if (self.state == 1) then
			self.state = 2;
			self:add_message (ent,	
			  "Mon enfant a t enlev! Ils l'ont enlev! " ..
			  "Il avait t cueillir des champignons dans la fort mais il n'est jamais revenu. " ..
			  "C'est surement les daphyrings qui me l'ont pris! Qui sait ce qu'il feront de lui? " ..
			  "A ce qu'on dit, ils mangent les enfants... Vous vous rendez compte? Oh, mon dieu... " ..
			  "Etranger, seriez vous prt a m'aider?",
			  {"OUI|Bien sur, je serais ravi de vous aider. Que dois-je faire?",
			   "NON|Non dsol, j'ai mieux a faire..."});
		elseif (self.state == 3) then
			self:add_message (ent, "Vous tes encore la? Vous devriez tre en train de chercher mon enfant!",
			{"CIAO|Oui, oui, c'est bon, j'y vais...",
			 "DAPHYS|Je n'ai pas trouv les daphyrings... ils sont ou deja?",
			 "NON|J'ai chang d'avis, trouvez quelqu'un d'autre ..."});
		end
	end
	if (msg == "OUI") then 
		if (self.state == 2) then -- on a repondu oui a "seriez vous pret a m'aider"
		  self.state = 3;
		  self:add_message (ent,	
			"Merci, merci! Dbarassez vous de ces horribles insectes et ramenez-moi mon enfant! " ..
			"Prenez ce jouet, il lui appartient. Quand vous l'aurez retrouv donnez-le lui, il vous suivra...",
			{"CIAO|D'accord, je reviendrais avec lui le plus vite possible...",
			 "DAPHYS|Moi je veux bien, mais ou il sont ces daphyrings?",
			 "NON|Finalement j'ai chang d'avis..."});
		end
	elseif (msg == "NON") then -- "on veut pas ou plus l'aider"
		self.state = 1; -- on retourne en 1 obligatoirement
		self:add_message (ent, 
		  "Mais alors, qui va m'aider? Oh, je vous en supplie mon brave homme... Aidez-moi...",
		  {"MOUSEHIT|Bon, c'tait quoi deja votre problme?"});
	elseif (msg == "DAPHYS") then
	-- note: les questions/reponses doivent aussi, plus tard, dpendre du fait que on ai trouve les daphys ou non
		if (self.state == 3) then
			self:add_message (ent,
			  "Ces bestioles ont mont leur camp au nord-est du village, prs de la foret. " ..
			  "Ils viennent faire leurs courses au village, c'est vraiment rpugnant. " ..
			  "Ils mritent la mort! ",
			  {"OK|Au nord-est hein? Je vais aller y jeter un oeil..."});
		end
	end
	return 1;
end

call_baril_4 = {};

function call_baril_4.on_create (self)
	self.state = 1;
end;


function call_baril_4.on_tell (self, ent, msg)
	ark.log (self:get_name() .. " was told " .. msg .. "(state was: " .. self.state .. ")");
	if ( msg == "MOUSEHIT") then -- click on the barrel number 4
		if (self.state == 1) then
			self.state = 2;
		elseif ( self.state == 2) then -- click on the barrel
			self.state = 3;
		elseif ( self.state == 3) then -- click on the barrel
			self.state = 1;
		end
	end
	return 1;
end
